\ s-config.fs -- save/restore settings to flash  -- 29Apr13 rjn
\
] here  ( *start)
\
1 [if] \ ------------------------[ hold register ]-----------------------------
\ 
\ ----- hold 
config-block constant #f-hold
-: save-hold   #f-hold ##p!  hold0 #  fwrite-quad ;
-: @f-hold  ( - lsb ... msb)   #f-hold ## @qflash ;
-: /hf  @f-hold  !hold ;  \ init hold from config block
\
\ ----- hold defaults
\ -: hold-def ; \ label for looking at defaults
here constant hold-default
$e8 , $03 , $00 , $00 ,  \ 1000 Hz, lsb written first
-: %h  hold-default ##  @qflash  !hold ; \ init hold from default 
\ 
[then] \ ----------------------------------------------------------------------
\ 
0 [if] \ --------------------[ hold phase register ]--------------- 23Jan13 rjn
\ 
\ ----- phold
[ config-block 4 + ] constant #f-phold
-: save-phold   #f-phold ##p!  phold #@  !f ;
-: /ph   #f-phold ##p!  @f  phold #! ;  \ init phold from flash
\
\ ----- afreq defaults
\ -: phold-def ;
here constant phold-default
$00 , 
-: %ph  phold-default ##p!  @f phold #! ; \ init phold from default 
\ 
[then] \ ----------------------------------------------------------------------
\  
1 [if] \ -----------------------[ afreq register ]-----------------------------
\ 
\ ----- afreq 
[ config-block 5 + ] constant #f-afreq
-: save-afreq   #f-afreq ##p!  afreq #  fwrite-quad ;
-: /af  #f-afreq ##  @qflash  afreq # !quad ;  \ init afreq from flash
\
\ ----- afreq defaults
\ -: afreq-def ;
here constant afreq-default
$37 , $86 , $00 , $00 ,  \ 1000 Hz, lsb written first
-: %af  afreq-default ##  @qflash  afreq #  !quad ; \ init afreq from default 
\ 
[then] \ ----------------------------------------------------------------------
\ 
1 [if] \ ----------------------[ aphase register ]-----------------------------
\ 
\ ----- aphase
[ config-block 9 + ] constant #f-aphase
-: save-aphase   #f-aphase ##p!  aphase #@  !f ;
-: /ap  #f-aphase ##p!  @f  aphase #! ;  \ init aphase from flash
\
\ ----- aphase defaults
\ -: aphase-def ;

here constant aphase-default
$00 , 
-: %ap  aphase-default ##p!  @f aphase #! ; \ init aphase from default 
\ 
[then] \ ----------------------------------------------------------------------
\  
0 [if] \ -----------------------[ bfreq register ]-----------------------------
\ 
\ ----- bfreq 
[ config-block 10 + ] constant #f-bfreq
-: save-bfreq   #f-bfreq ##p!  bfreq #  fwrite-quad ;
-: /bf   #f-bfreq ##  @qflash  bfreq # !quad ;  \ init bfreq from flash
\
\ ----- bfreq defaults
\ -: bfreq-def ; 

here constant bfreq-default
$37 , $86 , $00 , $00 ,  \ 1000 Hz, lsb written first
-: %bf  bfreq-default ##  @qflash  bfreq #  !quad ; \ init afreq from default 
\ 
[then] \ ----------------------------------------------------------------------
\ 
0 [if] \ ----------------------[ bphase register ]-----------------------------
\ 
\ ----- bphase
[ config-block 14 + ] constant #f-bphase
-: save-bphase   #f-bphase ##p!  bphase #@  !f ;
-: /bp  #f-bphase ##p!  @f  bphase #! ;  \ init bphase from flash
\
\ ----- bphase defaults
\ -: bphase-def ;
here constant bphase-default
$00 , 
-: %bp  bphase-default ##p!  @f bphase #! ; \ init bphase from default 
\ 
[then] \ ----------------------------------------------------------------------
\  
1 [if] \ -----------------------[ ascale register ]----------------------------
\ 
\ ----- ascale 
[ config-block 15 + ] constant #f-ascale
-: save-ascale   #f-ascale ##p!  ascale #  fwrite-quad ;
-: /ad  #f-ascale ##  @qflash ascale # !quad ;  \ init afreq from flash
\
\ ----- ascale defaults
\ -: ascale-def ;
here constant ascale-default
$d0 , $17 , $5c , $22 ,  \ 125 MHz clock, lsb written first
-: %ad  ascale-default ##  @qflash  ascale # !quad ; \ init ascale from default 
\ 
[then] \ ----------------------------------------------------------------------
\  
0 [if] \ -----------------------[ bscale register ]-----------------------------
\ 
\ ----- bscale
[ config-block 19 + ] constant #f-bscale
-: save-bscale   #f-bscale ##p!  bscale #  fwrite-quad ;
-: /bd  #f-bscale ##  @qflash  bscale # !quad ;  \ init afreq from flash
\
\ ----- afreq defaults
\ -: bscale-def ;
here constant bscale-default
$d0 , $17 , $5c , $22 ,  \ 125 MHz clock, lsb written first
-: %bd  bscale-default ##  @qflash  bscale # !quad ; \ init afreq from default 
\ 
[then] \ ----------------------------------------------------------------------
\  
0 [if] \ -----------------------[ address register ]---------------------------
\ 
\ ----- adr
[ config-block 23 + ] constant #f-adr
-: save-adr   #f-adr ##p!  adr #@ !f ;
-: @f-adr  ( - n)   #f-adr ##p!  @f ;
-: /adr  @f-adr  adr #! ;  \ init adr from flash
\
\ ----- adr default
\ -: adr-def ;
here constant adr-default
$00 ,  \ global address
-: %adr  adr-default ##p!  @f  adr #! ; \ init adr from default 
\ 
[then] \ ----------------------------------------------------------------------
\  
0 [if] \ ------------------------[ open drain flag ]---------------------------
\ 
\ ----- od
[ config-block 24 + ] constant #f-od
-: save-od   #f-od ##p!  od? #@ !f ;
\ -: @f-od  ( - n)   #f-od ##p!  @f ;
-: /od  ( @f-od)  #f-od ##p!  @f  od? #! ;  \ init od flag from flash
\
\ ----- od default
\ -: od-def ;
here constant od-default
$ff ,  \ push-pull
-: %od  od-default ##p!  @f  od? #! ; \ init od from default 
\ 
[then] \ ----------------------------------------------------------------------
\  
0 [if] \ ---------------------------[ 9851 flag ]------------------------------
\ 
\ ----- 9851
[ config-block 25 + ] constant #f-9851
-: save-9851   #f-9851 ##p!  9851? #@ !f ;
-: /9851  #f-9851 ##p!  @f  9851? #! ;  \ init 9851 flag from flash
\
\ ----- 9851 default (9850)
\ -: 9851-def ;
here constant 9851-default
$00 ,  \ 9850
-: %9851  9851-default ##p!  @f  9851? #! ; \ init 9851 from default 
\ 
[then] \ ----------------------------------------------------------------------
\  
0 [if] \ ---------------------------[ emit? flag ]------------------------------
\ 
\ ----- emit?
[ config-block 26 + ] constant #f-emit?
-: save-emit?   #f-emit? ##p!  emit? #@ !f ;
-: /eflag  #f-emit? ##p!  @f  emit? #! ;  \ init emit? flag from flash
\
\ ----- emit? default (responsive)
\ -: emit?-def ;
here constant emit?-default
$ff ,  \ responsive
-: %eflag  emit?-default ##p!  @f  emit? #! ; \ init emit? from default 
\ 
[then] \ ----------------------------------------------------------------------
\  
0 [if] \ ------------------------------[ mask ]--------------------------------
\ 
\ ----- mask
[ config-block 27 + ] constant #f-mask
-: save-mask   #f-mask ##p!  mask #@ !f ;
-: /lmask  #f-mask ##p!  @f  mask #! ;  \ init mask from flash
\ 
\ ----- mask default (listen)
\ -: mask-def ;
here constant mask-default
$ff ,  \ listen
-: %lmask  mask-default ##p!  @f  mask #! ; \ init mask from default 
\ 
[then] \ ----------------------------------------------------------------------
\  
0 [if] \ -----------------------------[ gmask ]--------------------------------
\ 
\ ----- gmask
[ config-block 28 + ] constant #f-gmask
-: save-gmask   #f-gmask ##p!  gmask #@ !f ;
-: /gmask  #f-gmask ##p!  @f  gmask #! ;  \ init gmask from flash
\ 
\ ----- gmask default
\ -: gmask-def ;
here constant gmask-default $ff ,
-: %gmask  gmask-default ##p!  @f  gmask #! ; \ init gmask from default 
\ 
[then] \ ----------------------------------------------------------------------
\  
0 [if] \ -----------------------------[ band ]---------------------------------
\ now in xram -- 30Apr rjn
\ ----- band
[ config-block 29 + ] constant #f-band
-: save-band   #f-band ##p!      ~band #@ !f ;
-: /band       #f-band ##p!  @f  ~band #! ;  \ init band from flash
\ 
\ ----- band default
\ -: band-def ;
here constant band-default $00 ,  \ 80M
-: %band  band-default ##p!  @f  ~band #! ; \ init band from default 
\ 
[then] \ ----------------------------------------------------------------------
\  
0 [if] \ ----------------------------[ sideband ]------------------------------
\ 
\ ----- side
[ config-block 30 + ] constant #f-side
-: save-side   #f-side ##p!      ~side #@ !f ;
-: /side       #f-side ##p!  @f  ~side #! ;  \ init sideband from flash
\ 
\ ----- side default
\ -: side-def ;
here constant side-default $01 ,  \ sb1
-: %side  side-default ##p!  @f  ~side #! ; \ init side from default 
\ 
[then] \ ----------------------------------------------------------------------
\  
0 [if] \ -------------------------[ sx146 menu choice ]------------------------
\ 
\ ----- menu choice
[ config-block 29 + ] constant #f-sx146-choice
-: save-sx146-choice   #f-sx146-choice ##p!   ~sx146-choice #@ !f ;
-: /sx146-choice       #f-sx146-choice ##p!  @f  ~sx146-choice #! ;  \ init from flash
\ 
\ ----- menu default
\ -: sx146-choice-def ;
here constant sx146-choice-default $1e ,
-: %sx146-choice  sx146-choice-default ##p!  @f  ~sx146-choice #! ; \ init from default 
\ 
[then] \ ----------------------------------------------------------------------
\ 
\ 
0 [if] \ ----- debug
: .cfg  0 # gp8 #!
   16 #  6 #for
      cr config-block ## gp8 #@  ai>adr  dh. space 
      16 #  5 #for 
         config-block ## gp8 #@  ai>adr p! |@p h.
         [ gp8 inc ]
      5 #next
   6 #next cr ;
[then] \ ------------    
\  
\ 
\ FYI -- freq table is in last 256 bytes of config-block
\ DON'T ALLOCATE IN THIS RANGE! 
\ 
\ 
-: !cfg  erase-config       ( save-sx146-choice)
   save-hold   save-phold   save-afreq   save-aphase  
   ( save-bfreq  save-bphase)  save-ascale  ( save-bscale  save-adr) 
   ( save-od     save-9851    save-emit?   save-mask    save-gmask)  
   ( save-band)   save-mxtable  save-fxtable ( save-side) ;
-: 0regs  0temp  0freq  0prod  0scale ;
-: (/cfg)  /hf  /ph  /af  /ap /bf   /bp  ( /sx146-choice)
           /ad  /bd  /adr /od /9851 /eflag /lmask /gmask ( /band) ( /side) ;
-: (//)    %h   %ph  %af  %ap %bf   %bp   ( %sx146-choice)
           %ad  %bd  %adr %od %9851 %eflag %lmask %gmask ( %band) ( %side) ;
\ if hold flash bytes are all $ff (cfg not saved), init from defaults 
-: /cfg   restore-fxtable  restore-mxtable  
   0regs  $ff # mask #!  $ff # gmask #! 
   @f-hold xor push xor pop ior 0=if drop (//) ; then drop (//) (/cfg) ;
\ 
here ( stop marker) [ swap -  cr .( s-config.fs          ) . .( bytes) ]
\ 
0 [if] \ ------------------------[ revisions ]---------------------------------
\ 
Date	By  Comment
=======	=== ===================================================================
04May13 rjn side is now in xram -- also, one side per band
29Apr13 rjn now band and sx146 menu choice are in xram.  
	      New save block at $7600).  Added save/restore
             to/from flash ( save-mxtable, restore-mxtable)
25Apr13 rjn added band, gmask (oversight) and adjusted start of ftable to
              last 256 bytes of config block (768 avail. for other regs)
21Apr13 rjn changed to use @qflash instead of fread-quad
20Apr13 rjn reworked for ftable storage in config-block, restore to xram
17Apr13 rjn added 1freq frequency register
09Apr13 rjn changed hold to hold0
05Apr13 rjn checked for swis.  Enabled save-phold.  Eliminated old defs.
24Jan13 rjn added listen mask
22Jan13 rjn added flag for conditional emit
20Jan13 rjn removed phold register (skipped over its byte)
26Sep12 rjn fixed incorrect references to "adr" for 9851? and od?
04Sep12 rjn eliminated header defs to reduce code size
03Sep12 rjn added adr register
31Aug12 rjn added conditional init for /cfg.  Also zeroed out volatile regs.
30Aug12 rjn added phase registers
16Aug12 rjn initial version
\ 
[then] \ ----------------------------------------------------------------------
