\ dstro_main.fs -- dstro application -- 21Apr14 rjn
\
]  here ( *start)
\ 
\ -----[ main processing, turnkey word ] 
\ : v  ver$ ;
\ 
\ 
-: 'ver$  lstring "  DSTRO 18Mar14"
\ 
-: ie>hold  @ie-acc !hold ;
-: ?switch  ie-switch if. led-off [ p04 set ] ; then led-on [ p04 clr ] ;

-: /app  /chip  led-off  /lcd  /ie  /timer0  /dds  /freqs  !dec /pwm ;

\ -: splash   'ver$ line2  qtest ;
-: splash  0lcd  'ver$  lcd-coff ;
\ -: persist  led-off  10 #  7 #for  100 # ms  7 #next ;
-: flutter  8 #  7 #for  [ led toggle ]  40 # ms  7 #next ;

1 [if] \ ------------------[ production go ]-----------------------------------
\ 
-: go  /app
   splash  persist  flutter
\   0 # @ftable  !ie-acc  ie>hold  /smode 
   restore-xtable  
   ?duty  ?rate  
   0 # @fxtable  !ie-acc  ie>hold  /smode
   0lcd  lcd-coff  ?.sopt  do-updates  ( !0.1hz)  ( ?rate)  
   begin  
      ie-switch 0=if. 
         ie>hold @hold<  @hold< 0 # !fxtable 
            ?ie-up  main-menu 
         !hold hold>ie 
         do-updates 
      then  ?update
   again
\ 
[then] \ ----------------------------------------------------------------------

0 [if] \ ---------------------[ test go ]--------------------------------------
\ 
-: go  /app  0lcd lcd-coff
   begin
     @option  dup !pwm  line1  h.lcd  25 # ms 
   again
\ 
[then] \ ----------------------------------------------------------------------


here  ( *stop) [ swap -  ( --)
cs? [if] cr .( dstro_main.fs      ) . .( bytes) [else] drop [then]
]

\ 
\ 
0 [if] ---------------------[ Revision History ]-------------------------------
\ 
Date	  By    Description
======= === ===================================================================
140421  rjn production release (1.0.0)
140217  rjn hardware checkout
131031  rjn added flags initialization
131016  rjn different versions of go for tethered and standalone
130819  rjn version tailored for 850 chip
130809  rjn initial version for itest -- cloned from DCON
\ 
[then] \ ----------------------------------------------------------------------

