\ rates.fs -- DSTRO rate tables, etc. -- 13Mar14 rjn
\ 
\ 
] here ( *start)
\ 
-: persist  led-off  13 #  7 #for  80ms-delay  7 #next ;
\ 
\ -----------------------------[ ie rate selection ]---------------------------
\ 
:m !0.01hz  0 # !bx4 m; 
:m !0.1hz   1 # !bx4 m; 
:m !1hz     2 # !bx4 m;
:m !10hz    3 # !bx4 m;
:m !100hz   4 # !bx4 m;
\ 
-: ?rate   @bx4
          0=if drop /ie-step     ; then
   |1xor  0=if drop /ie-step10   ; then  |1xor
   |2xor  0=if drop /ie-step100  ; then  |2xor 
   |3xor  0=if drop /ie-step1k   ; then  |3xor
   |4xor  0=if drop /ie-step10k  ; then  drop ; 
\ 
\ --- rate strings
\ 
-: '>      lstring "    >"
-: 'set    lstring "  set!"
-: 'hertz  lstring "  Hertz"
-: 'rpm    lstring "  rpm"

-: '0.01hz  lstring " 0.01"
-: .0.01hz  /line2  '> '0.01hz  'hertz ;

-: '0.1hz  lstring " 0.1"
-: .0.1hz  /line2  '> '0.1hz  'hertz ;

-: '1hz  lstring " 1"
-: .1hz  /line2 '> '1hz 'hertz ;

-: '10hz  lstring " 10"
-: .10hz  /line2 '> '10hz 'hertz ;

-: '100hz  lstring " 100"
-: .100hz  /line2 '> '100hz 'hertz ;
\ 
-: (?.rate)   /line2  @bx4
          0=if drop '0.01hz ; then
   |1xor  0=if drop '0.1hz  ; then  |1xor
   |2xor  0=if drop '1hz    ; then  |2xor 
   |3xor  0=if drop '10hz   ; then  |3xor
   |4xor  0=if drop '100hz  ; then  drop ;
\ 
-: ?.rate  (?.rate)  'hertz 'set persist ;
\ 
-: '0.01hz-short  lstring " r=0.01"
-: '0.1hz-short   lstring " r=0.1"
-: '1hz-short     lstring " r=1"
-: '10hz-short    lstring " r=10"
-: '100hz-short   lstring " r=100"

-: '0.6rpm-short    lstring " r=0.6"
-: '6rpm-short      lstring " r=6"
-: '60rpm-short     lstring " r=60"
-: '600rpm-short    lstring " r=600"
-: '6000rpm-short   lstring " r=6000"
 
-: ?.srate=hertz   @bx4
          0=if drop '0.01hz-short ; then
   |1xor  0=if drop '0.1hz-short  ; then  |1xor
   |2xor  0=if drop '1hz-short    ; then  |2xor 
   |3xor  0=if drop '10hz-short   ; then  |3xor
   |4xor  0=if drop '100hz-short  ; then  drop ;

-: ?.srate=rpm   @bx4
          0=if drop '0.6rpm-short  ; then
   |1xor  0=if drop '6rpm-short    ; then  |1xor
   |2xor  0=if drop '60rpm-short   ; then  |2xor 
   |3xor  0=if drop '600rpm-short  ; then  |3xor
   |4xor  0=if drop '6000rpm-short ; then  drop ;

\ 
here ( *stop) [ swap -  cr .( rates.fs           ) . .( bytes) ]
\ 
0 [if] ------------------------[ revisions ]-----------------------------------
\ 
Date	  By  Comment
======= === ==============================================================
13Mar14 rjn removed from ie.fs
\ 
[then] \ ----------------------------------------------------------------------
