\ utils.fs  -- for DACS -- 10aug13 rjn
\ 
] here
\ 
\ :m " 34 parse here there place here there [ c@ 1 + ] allot m;

-: (digit)   -10 # + -if -39 # + then 97 # + ; 
-: d+  |d+ ;  \ |d+ added to misc8051.fs -- 13Feb08 rjn
-: u/mod |u/mod ;
-: hmod  ( n -)  16 # u/mod ;  \ 22Jan13 rjn
-: depth S #@ invert ;
\ 
: dnegate swap invert swap invert 1 ## d+ ;
\ 
: 10000s 0 # begin push -10000 ## d+ -if 10000 ## d+ pop ; then pop 1+ again
: 1000s  0 # begin push  -1000 ## d+ -if  1000 ## d+ pop ; then pop 1+ again
: 100s   0 # begin push   -100 ## d+ -if   100 ## d+ pop ; then pop 1+ again
\ 
-: 1sec  250 # ms  250 # ms  250 # ms  250 # ms ;
\ 
\ for serial and lcd strings
\ :m " 34 parse here there place here there [ c@ 1 + ] allot m;
\ 
0 [if] \ -------------------[ only if serial port ]----------------------------
\ 
-: sign -if negate 45 # emit ; then ;
-: space 32 # emit ;
-: cr 13 # emit 10 # emit ;
-: digit   (digit) emit ;
\ Accept leading zeroes to save code.
-: (u.) 10 # u/mod 10 # u/mod digit digit digit ;
-: u. (u.) space ;
-: . sign u. ;
-: du.   swap (u.) u. space ;
-: (h.) ( 16 # u/mod) hmod digit digit ;
-: h.1  ( n -)  hmod drop digit ; 
-: h. (h.) space ;
: dh. [ char $ ] # emit (h.) h. ;
-: .s S #@ dup invert (u.)  62 # emit space a! begin @+ a 0=if 2drop ;
   then drop . again
: .x S #@ dup invert (h.) 62 # emit space a! begin @+ a 0=if 2drop ;
   then drop h. again
-: .sraw  S #@ a! begin @+ a 0=if 2drop ; then drop (emit) again
\ :m 2dup  |over |over m;  \ added to mide-misc8051.fs
\ 
\ Display double numbers (16 bits).
\ 
: ud. 10000s digit 1000s digit 100s digit drop 10 # u/mod digit digit
   space ;
: dsign -if dnegate 45 # emit ; then ;
: d. dsign ud. ;
\ 
[then] \ ----------------------------------------------------------------------
\ 
here ( * stop marker) [ swap -  ( -- n)
cs? [if] cr .( utils              ) . .( bytes) [else] drop [then]
]
\    
\ 
0 [if] ------------------------[ revisions ]-----------------------------------
\ 
Date	   By  Comment
=======	=== ===================================================================
10Aug13  rjn changed for compilation summary, renamed from prog-utils.fs
\
[then] \ ----------------------------------------------------------------------

