\ duty.fs -- DSTRO duty cycle table -- 17Mar14 rjn
\ 
\ 
] here ( *start)
\
\ 
\ --------------------------[ duty cycle selection ]---------------------------
\ 
                                       \ measured duty cycle % (ratio in ms)
:m !10%  0 # !bx5   m;  
:m !20%  1 # !bx5   m;  
:m !30%  2 # !bx5   m;  
:m !40%  3 # !bx5   m;  
:m !50%  4 # !bx5   m;  
:m !60%  5 # !bx5   m;  
:m !70%  6 # !bx5   m;  
:m !80%  7 # !bx5   m;  
:m !90%  8 # !bx5   m;  
\ 
-: ?duty   @bx5
          0=if drop $b1 # !pwm  ; then         \ 0.300/3.32 = 9.0 
   |1xor  0=if drop $b7 # !pwm  ; then  |1xor  \ 0.680/3.32 = 20.5
   |2xor  0=if drop $c0 # !pwm  ; then  |2xor  \ 1.00/3.32  = 30.1
   |3xor  0=if drop $cc # !pwm  ; then  |3xor  \ 1.36/3.32  = 40.96
   |4xor  0=if drop $d8 # !pwm  ; then  |4xor  \ 1.68/3.32  = 50.6
   |5xor  0=if drop $e3 # !pwm  ; then  |5xor  \ 1.98/3.32  = 59.6
   |6xor  0=if drop $f0 # !pwm  ; then  |6xor  \ 2.36/3.32  = 71.1
   |7xor  0=if drop $f8 # !pwm  ; then  |7xor  \ 2.66/3.32  = 80.1
   |8xor  0=if drop $fe # !pwm  ; then  drop ; \ 3.00/3.32  = 90.4
\ 
\ --- duty cycle strings
\ 
\ -: '>      lstring "    >"
\ -: 'set    lstring "  set!"
-: 'duty  lstring "  duty"
-: >ditem  /line2  3 # n_lcd '> ;

-: '10%   lstring " 10%"
-: .10%  >ditem '10% ;

-: '20%  lstring " 20%"
-: .20%  >ditem '20% ;

-: '30%  lstring " 30%"
-: .30%  >ditem '30% ;

-: '40%  lstring " 40%"
-: .40%  >ditem '40% ;

-: '50%  lstring " 50%"
-: .50%  >ditem '50% ;

-: '60%  lstring " 60%"
-: .60%  >ditem '60% ;

-: '70%  lstring " 70%"
-: .70%  >ditem '70% ;

-: '80%  lstring " 80%"
-: .80%  >ditem '80% ;

-: '90%  lstring " 90%"
-: .90%  >ditem '90% ;

\ 
-: (?.duty)   /line2  @bx5
          0=if drop '10% ; then
   |1xor  0=if drop '20% ; then  |1xor
   |2xor  0=if drop '30% ; then  |2xor 
   |3xor  0=if drop '40% ; then  |3xor
   |4xor  0=if drop '50% ; then  |4xor
   |5xor  0=if drop '60% ; then  |5xor
   |6xor  0=if drop '70% ; then  |6xor
   |7xor  0=if drop '80% ; then  |7xor
   |8xor  0=if drop '90% ; then  drop ;

-: ?.duty  (?.duty)  'duty 'set  persist ;
\ 
-: '10%-short  lstring " d=10%"
-: '20%-short  lstring " d=20%"
-: '30%-short  lstring " d=30%"
-: '40%-short  lstring " d=40%"
-: '50%-short  lstring " d=50%"
-: '60%-short  lstring " d=60%"
-: '70%-short  lstring " d=70%"
-: '80%-short  lstring " d=80%"
-: '90%-short  lstring " d=90%"
\ 
-: ?.sduty   @bx5
          0=if drop '10%-short ; then
   |1xor  0=if drop '20%-short ; then  |1xor
   |2xor  0=if drop '30%-short ; then  |2xor 
   |3xor  0=if drop '40%-short ; then  |3xor
   |4xor  0=if drop '50%-short ; then  |4xor
   |5xor  0=if drop '60%-short ; then  |5xor
   |6xor  0=if drop '70%-short ; then  |6xor 
   |7xor  0=if drop '80%-short ; then  |7xor
   |8xor  0=if drop '90%-short ; then  drop ;

\ 
here ( *stop) [ swap -  cr .( duty.fs            ) . .( bytes) ]
\ 
0 [if] ------------------------[ revisions ]-----------------------------------
\ 
Date	  By  Comment
======= === ==============================================================
17Mar14 rjn original version cloned from rates.fs
\ 
[then] \ ----------------------------------------------------------------------
