\ options.fs -- side menu for options -- 04May13 rjn
\ 
]  here ( *start)
\
-: persist  7 # 7 #for 100 # ms  7 #next ;

-: h.owait  0lcd  h.lcd flutter ?bswitch-down  ?bswitch-up ;
-: odepth.lcd   depth 0=if drop ; then drop h.owait ;

\ 
\ -----[ main menu title ]
\ 
-: 'omenu   lstring " Option Menu  "
-: .omenu   line1 'omenu ( ?'side) ;

-: ?o-activity  \ exits if switch or ie activity 
   @option dup begin
      drop  @option |over xor bswitch? ior
   until drop drop ;

0 [if] \ --------------------------- sideband option --------------------------
\ 
\  
\ -----[ sideband submenu ]
\ 
cpuHERE constant ~sideband-choice 1 cpuALLOT

-: save-sideband-choice     @option  ~sideband-choice #! ;
-: restore-sideband-choice  ~sideband-choice #@  !option  ;

\ : /sideband-choice  30 # sideband-choice #! ;

-: 'sideband-menu  lstring "  Sideband Menu  "
-: .sideband-menu  0lcd lcd-coff line1 'sideband-menu ;

-: 'sideband-choice  lstring " >sideband"
-: .sideband-choice  line2 'sideband-choice 7 # n_lcd ;

-: '>      lstring " >"
-: 'set    lstring "  set"

-: .sb1    line2 '> 'sb1  12 # n_lcd ;

-: .sb2    line2 '> 'sb2  12 # n_lcd ;

-: 'sb1-set   lstring "  sb1 set"
-: 'sb2-set   lstring "  sb2 set"

-: (xsb)   line2 ?'side 'set persist ;
-: xsb1   !sb1  (xsb) ;
-: xsb2   !sb2  (xsb) ;

:m ?xside  ( n - n')  
   |2xor 0=if drop xback ; then |2xor  
   save-sideband-choice m;

-: xside  @1of3 ?xside
         0=if drop xsb1 xback ; then 
   |1xor 0=if drop xsb2 xback ; then drop ;

-: side-menu  @1of3  ?shown    
         0=if drop .sb1  ; then 
   |1xor 0=if drop .sb2  ; then |1xor
   |2xor 0=if drop .back ; then drop ;

-: do-side 
   begin side-menu ?o-activity bswitch 0=until. ?bswitch-up 
   xside ?switch-up ;

-: ?next-side  @side  \ attempt to go to the next side from current side
   |1xor 0=if drop 100 # !option  ; then |1xor
   |2xor 0=if drop  30 # !option  ; then drop ;

-: >sideband   /back  /last  /ie-step  .sideband-menu  ( restore-sideband-choice)
   ?next-side
   0 # begin drop  do-side back? until drop ( /back ?switch-up) ;

[then] \ ---------------------------------------------------------------------- 
\ 
\ -----[ rate menu ]
\ 
cpuHERE constant ~rate-choice 1 cpuALLOT

-: save-rate-choice     @option  ~rate-choice #! ;
-: restore-rate-choice  ~rate-choice #@  !option  ;

\ -: /rate-choice  30 # rate-choice #! ;

-: 'rate  lstring " >rate"
-: .rate  line2 'rate 11 # n_lcd ;

-: 'rate-menu  lstring "    Rate Menu"
-: .rate-menu  line1 'rate-menu 4 # n_lcd ; 
\ -: 'rate-done  lstring "  rate selected  "
\ -: >rate  line2 'rate-done  persist ;

\ --- rate strings
-: '1hz  lstring " >1 Hertz"
-: .1hz  line2 '1hz 9 # n_lcd ;
-: '1hz-done  lstring "  1 Hertz Steps  "
-: >1hz   !1hz line2 '1hz-done  persist ; 

-: '10hz  lstring " >10 Hertz"
-: .10hz  line2 '10hz 8 # n_lcd ;
-: '10hz-done  lstring " 10 Hertz Steps  "
-: >10hz  !10hz line2 '10hz-done  persist ;

-: '100hz  lstring " >100 Hertz"
-: .100hz  line2 '100hz 7 # n_lcd ;
-: '100hz-done  lstring " 100 Hertz Steps "
-: >100hz  !100hz line2 '100hz-done  persist ;

-: '1khz  lstring " >1"
-: .1khz  line2 '1khz 'khz  10 # n_lcd ;
-: '1khz-done  lstring " 1 kHz Steps"
-: >1khz  !1khz line2 '1khz-done  5 # n_lcd  persist ;

-: '10khz  lstring " >10 kHz"
-: .10khz  line2 '10khz 9 # n_lcd ;
-: '10khz-done  lstring " 10 kHz Steps"
-: >10khz  !10khz line2 '10khz-done  4 # n_lcd  persist ;

-: '100khz  lstring " >100 kHz"
-: .100khz  line2 '100khz 8 # n_lcd ;
-: '100khz-done  lstring " 100 kHz Steps"
-: >100khz  !100khz line2 '100khz-done  3 # n_lcd  persist ;

:m ?xrate  ( n - n)  
   |6xor 0=if drop xback ; then |6xor  
   save-rate-choice m;

-: xrate   @1of7  ?xrate
         0=if drop >1hz    xback ; then
   |1xor 0=if drop >10hz   xback ; then |1xor
   |2xor 0=if drop >100hz  xback ; then |2xor
   |3xor 0=if drop >1khz   xback ; then |3xor
   |4xor 0=if drop >10khz  xback ; then |4xor
   |5xor 0=if drop >100khz xback ; then drop ; 

-: rate-menu   @1of7 ?shown
         0=if drop .1hz    ; then 
   |1xor 0=if drop .10hz   ; then |1xor
   |2xor 0=if drop .100hz  ; then |2xor
   |3xor 0=if drop .1khz   ; then |3xor
   |4xor 0=if drop .10khz  ; then |4xor
   |5xor 0=if drop .100khz ; then |5xor
   |6xor 0=if drop .back   ; then drop ;

-: do-rate 
   begin rate-menu ?o-activity bswitch 0=until. ?bswitch-up 
   xrate ( ?bswitch-up) ;

-: >rate   /back  /last  .rate-menu  restore-rate-choice  
   0 # begin drop  do-rate back? until drop ;
\ 
\ 
\ -----[ cal menu ]
\ 
\ -: 'cal-title  lstring " : "
\ -: .cal-title  0lcd  line1 ( 'cal-title) ;

-: 'cal  lstring " >cal"
-: .cal  line2 'cal 12 # n_lcd ;

-: update-cal  update-lcd  ie>hold  ?dif.freq 'hertz ;

\ note: it takes ~ 15 ms to position to a line and write 16 chars
-: ?update-cal  @ticks0 -if update-cal  25 # !ticks0 then drop ;

-: >cal  ( update-freq)  /ie-step  #tempop # @qmxtable !hold  hold>ie  
\   @hold<  ( save, no offset)
   @hold< temp4 # !quad  0 ## 0 ## !cal-offset ( display with no offset)
\   @hold< cr h. h. h. h.
   0lcd  begin  ?update-cal  bswitch 0=until.
   #caltemp # @qmxtable !cal-offset    ( @cal-offset cr h. h. h. h.) 
   #tempop # @qmxtable  !hold  hold>ie  ?rate  xback ;
\   !hold hold>ie  ( restore, no offset) @hold<      cr h. h. h. h. ?rate xback ;
\ 
\ 
\ ------[ main menu ]
\ 
cpuHERE constant ~oitem 1 cpuALLOT

-: save-oitem     @option  ~oitem #! ;
-: restore-oitem  ~oitem #@  !option  ;

:m ?xoitem  ( n - n)  
   |2xor 0=if drop xback ; then |2xor  
   save-oitem m;

-: xoitem   @1of3  ?xoitem
         0=if drop >rate     ; then
   |1xor 0=if drop >cal      ; then drop ;
\ |1xor  |2xor 0=if drop >sideband ; then drop ;

-: ?item-select  
   bswitch 0=if. ?bswitch-up
\      odepth.lcd  \ debug
      save-oitem
      /back /last xoitem
      restore-oitem
      .omenu /ie-step  /last
\      odepth.lcd  \ debug
   then ;

-: omenu-items   @1of3 ?shown
         0=if drop .rate     ; then 
   |1xor 0=if drop .cal      ; then |1xor
\   |2xor 0=if drop .sideband ; then |2xor
   |2xor 0=if drop .back     ; then drop ;

-: /omenu  restore-oitem  /ie-step  /last  /back ;

\ just a rate setting menu for now
: option-menu   ?bswitch-up  /omenu  0lcd  lcd-coff .omenu 
   0 # begin drop omenu-items ?o-activity  ?item-select back? until drop 
   ?bswitch-up  ?rate ;

here ( *stop) [ swap -  cr .( options.fs        ) . .( bytes) ]
\ 
\  
0 [if] \ ------------------------[ revisions ]---------------------------------

Date	By  Comment
=======	=== ===================================================================
27May13 rjn eliminated sideband option -- use cal
04May13 rjn CAL now working
27Apr13 rjn initial version

[then] \ ----------------------------------------------------------------------
